import { useState, createElement, useEffect } from 'react';
import uniqid from 'uniqid';

var quizTypes = {
  INLINE: "inline",
  CONSISTENT: "consistent"
};

var styles = {"answer":"_1apQF","question":"_3gWRN"};

var QuestionComponent = function QuestionComponent(_ref) {
  var question = _ref.question,
    answerFunc = _ref.answerFunc,
    index = _ref.index,
    highlightAnswers = _ref.highlightAnswers,
    answers = _ref.answers,
    customization = _ref.customization,
    quizType = _ref.quizType,
    selectedQuestion = _ref.selectedQuestion,
    setSelectedQuestion = _ref.setSelectedQuestion;
  var _React$useState = useState(null),
    choosenAnswer = _React$useState[0],
    setChoosenAnswer = _React$useState[1];
  var answerQuestion = function answerQuestion(qid, aid) {
    setChoosenAnswer(aid);
    answerFunc === null || answerFunc === void 0 ? void 0 : answerFunc(qid, aid);
    setSelectedQuestion(index + 1);
  };
  return createElement("div", {
    className: styles.question
  }, (quizType === quizTypes.CONSISTENT && index === selectedQuestion || quizType === quizTypes.INLINE || !quizType) && createElement("div", null, createElement("span", null, customization.disableNumbers ? "" : index + 1 + ". ", question.text), question.answers.map(function (a) {
    var _answers$correctAnswe, _answers$correctAnswe2;
    return createElement("div", {
      key: a.id,
      className: styles.answer,
      style: {
        color: highlightAnswers && (answers === null || answers === void 0 ? void 0 : (_answers$correctAnswe = answers.correctAnswer) === null || _answers$correctAnswe === void 0 ? void 0 : _answers$correctAnswe.id) === a.id || answers !== null && answers !== void 0 && answers.correct && a.id === answers.answer.aid ? "green" : (answers === null || answers === void 0 ? void 0 : answers.answer.aid) === a.id ? "red" : "black",
        fontWeight: highlightAnswers && (answers === null || answers === void 0 ? void 0 : (_answers$correctAnswe2 = answers.correctAnswer) === null || _answers$correctAnswe2 === void 0 ? void 0 : _answers$correctAnswe2.id) === a.id || answers !== null && answers !== void 0 && answers.correct && a.id === answers.answer.aid ? "normal" : (answers === null || answers === void 0 ? void 0 : answers.answer.aid) === a.id ? "normal" : "lighter"
      }
    }, createElement("input", {
      type: "checkbox",
      defaultChecked: choosenAnswer === a.id || (answers === null || answers === void 0 ? void 0 : answers.answer.aid) === a.id,
      disabled: highlightAnswers || !!choosenAnswer,
      onClick: function onClick() {
        return answerQuestion(question.id, a.id);
      }
    }), createElement("label", null, " ", a.label));
  }), quizType === quizTypes.CONSISTENT && createElement("button", {
    onClick: function onClick() {
      return setSelectedQuestion(index + 1);
    }
  }, "next"), quizType === quizTypes.CONSISTENT && index > 0 && createElement("button", {
    onClick: function onClick() {
      return setSelectedQuestion(index - 1);
    }
  }, "previos")));
};

var styles$1 = {"modal":"_1rfeP","modal-main":"_1i7tJ","modal-content":"_2i6F-","modal-footer":"_2St3X","display-block":"_1gc1r","display-none":"_joWUX"};

var AsyncQuizResultComponent = function AsyncQuizResultComponent(_ref) {
  var quizResult = _ref.quizResult,
    preparedQuestions = _ref.preparedQuestions,
    customization = _ref.customization;
  return createElement("div", null, createElement("div", {
    style: {
      padding: "20px"
    }
  }, createElement("div", {
    style: {
      width: "100%",
      display: "flex",
      justifyContent: "space-around"
    }
  }, createElement("span", null, "Correct answers: ", quizResult.score.correctOutOf, "(", quizResult.score.correctPercentage, ")"), createElement("span", null, "Scored points: ", quizResult.score.costOutOf, "(", quizResult.score.costPercentage, ")"))), createElement("div", null, preparedQuestions.map(function (q, index) {
    return createElement(QuestionComponent, {
      key: index,
      index: index,
      question: q,
      highlightAnswers: true,
      answers: quizResult === null || quizResult === void 0 ? void 0 : quizResult.answers.find(function (a) {
        return a.id === q.id;
      }),
      customization: customization
    });
  })));
};

var QuizResultComponent = function QuizResultComponent(_ref) {
  var quizResult = _ref.quizResult,
    preparedQuestions = _ref.preparedQuestions,
    customization = _ref.customization;
  return createElement("div", null, createElement("div", {
    style: {
      padding: "20px"
    }
  }, createElement("div", {
    style: {
      width: "100%",
      display: "flex",
      justifyContent: "space-around"
    }
  }, createElement("span", null, "Correct answers: ", quizResult.score.correctOutOf, "(", quizResult.score.correctPercentage, ")"), createElement("span", null, "Scored points: ", quizResult.score.costOutOf, "(", quizResult.score.costPercentage, ")"))), createElement("div", null, preparedQuestions.map(function (q, index) {
    return createElement(QuestionComponent, {
      key: index,
      index: index,
      question: q,
      highlightAnswers: true,
      answers: quizResult === null || quizResult === void 0 ? void 0 : quizResult.answers.find(function (a) {
        return a.id === q.id;
      }),
      customization: customization
    });
  })));
};

var ResultModal = function ResultModal(_ref) {
  var quizResult = _ref.quizResult,
    preparedQuestions = _ref.preparedQuestions,
    handleClose = _ref.handleClose,
    showModal = _ref.showModal,
    customization = _ref.customization;
  var showHideClassName = showModal ? styles$1.modal + " " + styles$1['display-block'] : styles$1.modal + " " + styles$1['display-none'];
  return createElement("div", {
    className: showHideClassName
  }, createElement("section", {
    className: styles$1['modal-main']
  }, createElement("div", {
    className: styles$1['modal-content']
  }, createElement(QuizResultComponent, {
    quizResult: quizResult,
    preparedQuestions: preparedQuestions,
    customization: customization
  })), createElement("div", {
    className: styles$1['modal-footer']
  }, createElement("button", {
    type: "button",
    onClick: handleClose
  }, "Close"))));
};
var AsyncResultModal = function AsyncResultModal(_ref2) {
  var quizResult = _ref2.quizResult,
    preparedQuestions = _ref2.preparedQuestions,
    handleClose = _ref2.handleClose,
    showModal = _ref2.showModal,
    customization = _ref2.customization;
  var showHideClassName = showModal ? styles$1.modal + " " + styles$1['display-block'] : styles$1.modal + " " + styles$1['display-none'];
  return createElement("div", {
    className: showHideClassName
  }, createElement("section", {
    className: styles$1['modal-main']
  }, createElement("div", {
    className: styles$1['modal-content']
  }, createElement(AsyncQuizResultComponent, {
    quizResult: quizResult,
    preparedQuestions: preparedQuestions,
    customization: customization
  })), createElement("div", {
    className: styles$1['modal-footer']
  }, createElement("button", {
    type: "button",
    onClick: handleClose
  }, "Close"))));
};

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}

var getScore = function getScore(preparedAnswers, preparedQuestions) {
  var _preparedQuestions$re = preparedQuestions.reduce(function (acc, answer) {
      return {
        totalCost: acc.totalCost + (answer.cost ? +answer.cost : 0),
        totalNumber: acc.totalNumber + 1
      };
    }, {
      totalCost: 0,
      totalNumber: 0
    }),
    totalCost = _preparedQuestions$re.totalCost,
    totalNumber = _preparedQuestions$re.totalNumber;
  var _preparedAnswers$redu = preparedAnswers.reduce(function (acc, answer) {
      return {
        scoredCost: acc.scoredCost + (answer.correct && answer.cost ? +answer.cost : 0),
        scoredNumber: acc.scoredNumber + (answer.correct ? 1 : 0)
      };
    }, {
      scoredCost: 0,
      scoredNumber: 0
    }),
    scoredCost = _preparedAnswers$redu.scoredCost,
    scoredNumber = _preparedAnswers$redu.scoredNumber;
  return {
    scoredNumber: scoredNumber,
    scoredCost: scoredCost,
    correctPercentage: Math.floor(scoredNumber * 100 / totalNumber) + "%",
    costPercentage: totalCost ? Math.floor(scoredCost * 100 / totalCost) + "%" : "100%",
    correctOutOf: scoredNumber + "/" + totalNumber,
    costOutOf: scoredCost + "/" + totalCost
  };
};

var prepareQuestions = function prepareQuestions(questions) {
  return questions.map(function (q) {
    var correctAnswerId = uniqid();
    var answers = q.answers.reduce(function (acc, a) {
      return acc.includes(a) ? acc : [].concat(acc, [a]);
    }, []);
    return _extends({}, q, {
      id: uniqid(),
      answers: answers.map(function (a) {
        return {
          id: a === q.correctAnswer ? correctAnswerId : uniqid(),
          label: a
        };
      }),
      correctAnswer: {
        id: correctAnswerId,
        label: q.correctAnswer
      },
      cost: q.cost || 0
    });
  });
};
var prepareAnswers = function prepareAnswers(answers, preparedQuestions, answersCallback, setQuizResult, setShowResultModal) {
  var preparedAnswers = answers.map(function (a) {
    var _q$correctAnswer;
    var q = preparedQuestions.find(function (q) {
      return q.id === a.qid;
    });
    return {
      text: q === null || q === void 0 ? void 0 : q.text,
      correctAnswer: q === null || q === void 0 ? void 0 : q.correctAnswer,
      id: q === null || q === void 0 ? void 0 : q.id,
      cost: q === null || q === void 0 ? void 0 : q.cost,
      answer: a,
      correct: (q === null || q === void 0 ? void 0 : (_q$correctAnswer = q.correctAnswer) === null || _q$correctAnswer === void 0 ? void 0 : _q$correctAnswer.id) === a.aid
    };
  });
  var QuizResult = {
    answers: preparedAnswers,
    score: getScore(preparedAnswers, preparedQuestions)
  };
  setQuizResult(QuizResult);
  setShowResultModal(true);
  answersCallback(QuizResult);
};
var prepareAnswersAsync = function prepareAnswersAsync(answers, preparedQuestions, answersCallback, setQuizResult, setShowResultModal, checkQuestion) {
  try {
    return Promise.resolve(Promise.all(answers.map(function (a) {
      try {
        return Promise.resolve(new Promise(function (resolve) {
          try {
            var _temp2 = function _temp2(isCorrect) {
              resolve({
                text: q === null || q === void 0 ? void 0 : q.text,
                correctAnswer: isCorrect.correctValue || undefined,
                id: q === null || q === void 0 ? void 0 : q.id,
                cost: q === null || q === void 0 ? void 0 : q.cost,
                answer: a,
                correct: isCorrect.value
              });
            };
            var q = preparedQuestions.find(function (q) {
              return q.id === a.qid;
            });
            var _q$id2 = q === null || q === void 0 ? void 0 : q.id;
            return Promise.resolve(_q$id2 ? Promise.resolve(checkQuestion(a.aid, q === null || q === void 0 ? void 0 : q.id)).then(_temp2) : _temp2({
              value: false
            }));
          } catch (e) {
            return Promise.reject(e);
          }
        }));
      } catch (e) {
        return Promise.reject(e);
      }
    }))).then(function (preparedAnswers) {
      var updatedQuestions = preparedQuestions.map(function (q) {
        return {
          text: q.text,
          answers: q.answers,
          id: q.id,
          cost: q.cost || 0
        };
      });
      var QuizResult = {
        answers: preparedAnswers,
        score: getScore(preparedAnswers, updatedQuestions)
      };
      setQuizResult(QuizResult);
      setShowResultModal(true);
      answersCallback(QuizResult);
    });
  } catch (e) {
    return Promise.reject(e);
  }
};
var prepareStyles = function prepareStyles(customStyles) {
  var _customStyles$height = customStyles.height,
    height = _customStyles$height === void 0 ? "400px" : _customStyles$height,
    _customStyles$backgro = customStyles.backgroundColor,
    backgroundColor = _customStyles$backgro === void 0 ? "white" : _customStyles$backgro,
    _customStyles$fontFam = customStyles.fontFamily,
    fontFamily = _customStyles$fontFam === void 0 ? "Verdana, Arial, Helvetica, sans-serif" : _customStyles$fontFam,
    _customStyles$textCol = customStyles.textColor,
    textColor = _customStyles$textCol === void 0 ? "black" : _customStyles$textCol,
    _customStyles$disable = customStyles.disableNumbers,
    disableNumbers = _customStyles$disable === void 0 ? false : _customStyles$disable;
  return {
    height: height,
    backgroundColor: backgroundColor,
    fontFamily: fontFamily,
    textColor: textColor,
    disableNumbers: disableNumbers
  };
};

var styles$2 = {"app":"_PkCpU"};

var Quiz = function Quiz(_ref) {
  var questions = _ref.questions,
    _ref$customStyles = _ref.customStyles,
    customStyles = _ref$customStyles === void 0 ? {} : _ref$customStyles,
    answersCallback = _ref.answersCallback,
    resultsModal = _ref.resultsModal,
    quizType = _ref.quizType;
  var customization = prepareStyles(customStyles);
  var _React$useState = useState([]),
    preparedQuestions = _React$useState[0],
    setPreparedQuestions = _React$useState[1];
  var _React$useState2 = useState(null),
    quizResult = _React$useState2[0],
    setQuizResult = _React$useState2[1];
  var _React$useState3 = useState(false),
    showResultModal = _React$useState3[0],
    setShowResultModal = _React$useState3[1];
  var _React$useState4 = useState(0),
    selectedQuestion = _React$useState4[0],
    setSelectedQuestion = _React$useState4[1];
  useEffect(function () {
    setPreparedQuestions(prepareQuestions(questions));
  }, [questions]);
  var _React$useState5 = useState([]),
    quizAnswers = _React$useState5[0],
    setQuizAnswers = _React$useState5[1];
  var answerFunc = function answerFunc(qid, aid) {
    if (quizAnswers.find(function (a) {
      return a.qid === aid;
    })) return false;
    setQuizAnswers([].concat(quizAnswers, [{
      qid: qid,
      aid: aid
    }]));
    return true;
  };
  return createElement("div", {
    className: styles$2.app,
    style: {
      height: customization.height,
      fontFamily: customization.fontFamily,
      color: customization.textColor,
      backgroundColor: customization.backgroundColor
    }
  }, resultsModal && quizResult && createElement(ResultModal, {
    quizResult: quizResult,
    preparedQuestions: preparedQuestions,
    showModal: showResultModal,
    handleClose: function handleClose() {
      return setShowResultModal(false);
    },
    customization: customization
  }), preparedQuestions.map(function (question, index) {
    return createElement(QuestionComponent, {
      key: question.id,
      question: question,
      answerFunc: answerFunc,
      index: index,
      customization: customization,
      quizType: quizType,
      selectedQuestion: selectedQuestion,
      setSelectedQuestion: setSelectedQuestion
    });
  }), createElement("button", {
    onClick: function onClick() {
      return prepareAnswers(quizAnswers, preparedQuestions, answersCallback, setQuizResult, setShowResultModal);
    }
  }, "Submit"));
};

var styles$3 = {"app":"_1mAHz"};

var AsyncQuiz = function AsyncQuiz(_ref) {
  var questions = _ref.questions,
    _ref$customStyles = _ref.customStyles,
    customStyles = _ref$customStyles === void 0 ? {} : _ref$customStyles,
    answersCallback = _ref.answersCallback,
    resultsModal = _ref.resultsModal,
    checkQuestion = _ref.checkQuestion,
    quizType = _ref.quizType;
  var customization = prepareStyles(customStyles);
  var _React$useState = useState([]),
    preparedQuestions = _React$useState[0],
    setPreparedQuestions = _React$useState[1];
  var _React$useState2 = useState(null),
    quizResult = _React$useState2[0],
    setQuizResult = _React$useState2[1];
  var _React$useState3 = useState(false),
    showResultModal = _React$useState3[0],
    setShowResultModal = _React$useState3[1];
  var _React$useState4 = useState(0),
    selectedQuestion = _React$useState4[0],
    setSelectedQuestion = _React$useState4[1];
  useEffect(function () {
    setPreparedQuestions(questions);
  }, [questions]);
  var _React$useState5 = useState([]),
    quizAnswers = _React$useState5[0],
    setQuizAnswers = _React$useState5[1];
  var answerFunc = function answerFunc(qid, aid) {
    if (quizAnswers.find(function (a) {
      return a.qid === qid;
    })) return false;
    setQuizAnswers([].concat(quizAnswers, [{
      qid: qid,
      aid: aid
    }]));
    return true;
  };
  return createElement("div", {
    className: styles$3.app,
    style: {
      height: customization.height,
      fontFamily: customization.fontFamily,
      color: customization.textColor,
      backgroundColor: customization.backgroundColor
    }
  }, resultsModal && quizResult && createElement(AsyncResultModal, {
    quizResult: quizResult,
    preparedQuestions: preparedQuestions,
    showModal: showResultModal,
    handleClose: function handleClose() {
      return setShowResultModal(false);
    },
    customization: customization
  }), preparedQuestions.map(function (question, index) {
    return createElement(QuestionComponent, {
      key: question.id,
      question: question,
      answerFunc: answerFunc,
      index: index,
      customization: customization,
      quizType: quizType,
      selectedQuestion: selectedQuestion,
      setSelectedQuestion: setSelectedQuestion
    });
  }), (quizType === quizTypes.CONSISTENT && preparedQuestions.length <= selectedQuestion || quizType === quizTypes.INLINE || !quizType) && createElement("button", {
    onClick: function onClick() {
      return prepareAnswersAsync(quizAnswers, preparedQuestions, answersCallback, setQuizResult, setShowResultModal, checkQuestion);
    }
  }, "Submit"));
};

export { AsyncQuiz, Quiz };
//# sourceMappingURL=index.modern.js.map
